from machine import Pin
import socket

led = Pin(16, Pin.OUT)     # ピン１６番(GPIO16)をLED出力で割り付ける
sw1 = Pin(0, Pin.IN)       # ピン０番(GPIO0)をスイッチ入力で割り付ける
# 指定されたアドレスファミリ、ソケットタイプ、プロトコル番号を使い、新しいソケットを作成する
addr = socket.getaddrinfo('0.0.0.0', 80)[0][-1]
soc = socket.socket()
soc.bind(addr)   # socketの登録を行う
soc.listen(1)    # 接続を受け入れる事ができる様にします
print('listening on', addr)

while True:
    # クライアントの接続を待つ
    cl, addr = soc.accept()
    print('\r\nclient connected from', addr)
    # セッション開始
    cl_file = cl.makefile('rwb', 0)
    cl.send(b'Hello everyone\r\n')
    cl.send(b'Press only ENTER to end the session.\r\n')
    while True:
        bMsg = cl_file.readline()
        print(bMsg)
        if not bMsg or bMsg == b'\r\n':
            break                 # セッション終了
        sMsg = bMsg.decode()      # バイト列から文字列へ変換
        sMsg = sMsg.lower()       # 小文字に変換
        # コマンドの処理
        if sMsg[0:8] == 'command ':
            s = sMsg.split()
            if len(s) != 1:
                # ピン１６番(GPIO16)のLED処理
                if s[1] == 'gpio16':
                    if s[2] == 'on':
                        cl.send(b'yes sir! <(`_´)\r\n')
                        led.value(0)  # 点灯
                    elif s[2] == 'off':
                        cl.send(b'yes sir! <(`_´)\r\n')
                        led.value(1)  # 消灯
                    else:
                        cl.send(b'Command instruction error!\r\n')
                # ピン０番(GPIO0)のスイッチ処理
                elif s[1] == 'gpio0':
                    s = 'The state is ' + str(sw1.value()) + '. \r\n'
                    cl.send(s.encode())
                else:
                    cl.send(b'Command instruction error!\r\n')

    # ソケットを閉じる
    cl.close()
